myApp.directive('hcPieChart', function () {
                return {
                    restrict: 'E',
                    template: '<div></div>',
                    link: function (scope, element) {
                    	getEmployeeDetails(scope,element[0].baseURI+'reports/getBillabilityDetailsByMonth','line',element,"Employees By Functional Group");

                    	scope.clickMe= function() {
//                            if(scope.reportId == 1234){
//                            	scope.result = [{data:[{name:"ES", y:279},{name: "SAMP", y: 2},{name: "APPS", y: 1}]}]
//                            	scope.drawChart(element,'column');
//                            }
                            if(scope.reportId == 123){
                            	getEmployeeDetails(scope,element[0].baseURI+'reports/getEmployeesByFunctionalGroup','pie',element,"Employees By Functional Group");
                            	
                            }else {
                            	getEmployeeDetails(scope,element[0].baseURI+'reports/getBillabilityDetailsByMonth','line',element," Billability Monthly Trends");
                            }
                        }
                    }
                };
            }).controller('chartsController', function ($scope, $http, myFactory, $mdDialog, appConfig) {
            	
            	$scope.name = [];
            	$scope.records = [];
            	            	$scope.empSearchId = "";
            	            	//$scope.reports = $scope.reportId;
            	            	$scope.reports=[ {Name:"Employee Overview Report",Id:"1234"},{Name:"Employees By Functional Group",Id:"123"},{Name:"Billability Monthly Trends",Id:"12345"}];
            	            	
            	            	$scope.parentData = {
            	            			"employeeId": "",
            	            			"employeeName": "",
            	            			"emailId":"",
            	            			"role": "",
            	            			"shift": "",
            	            			"projectId":"",
            	            			"projectName":"",
            	            			"managerId":"",
            	            			"managerName":"",
            	            			"experience":"",
            	            			"designation":"",
            	            			"action":""
            	            	};
            	            	$scope.employees = [];
            	            	$scope.projects = [];
            	            	var getCellTemplate = '<p class="col-lg-12"><i class="fa fa-pencil-square-o fa-2x" aria-hidden="true" style="font-size:1.5em;margin-top:3px;cursor:pointer;" ng-click="grid.appScope.getRowData(row,\'Update\')"></i>'+
            	            	'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<i class="fa fa-minus-circle fa-2x" aria-hidden="true" style="font-size:1.5em;margin-top:3px;cursor:pointer;" ng-click="grid.appScope.getRowData(row,\'Delete\')"></i></p>';
            	            	$scope.gridOptions = {
            	            		paginationPageSizes : [ 10, 20, 30, 40, 50, 100],
            	            		paginationPageSize : 10,
            	            	    pageNumber: 1,
            	            		pageSize:10,
            	            		columnDefs : [ 
            	            			{field : 'employeeId',displayName: 'Employee ID', enableColumnMenu: true, enableSorting: true, width:120},
            	            			{field : 'employeeName',displayName: 'Name', enableColumnMenu: false, enableSorting: false},
            	            			{field : 'emailId',displayName: 'Email', enableColumnMenu: false, enableSorting: false},
            	            			{field : 'projectName',displayName: 'Project', enableColumnMenu: false, enableSorting: false},
            	            			{field : 'mobileNumber',displayName: 'Mobile No', enableColumnMenu: false, enableSorting: false}
            	            		]
            	            	};
            	            	$scope.gridOptions.data = $scope.records;
            	            	
            	            	$scope.getRowData = function(row, action){
            	            		$scope.parentData.employeeId = row.entity.employeeId;
            	            		$scope.parentData.employeeName = row.entity.employeeName;
            	            		$scope.parentData.emailId = row.entity.emailId;
            	            		$scope.parentData.role = row.entity.role;
            	            		$scope.parentData.shift = row.entity.shift;
            	            		$scope.parentData.projectId = row.entity.projectId;
            	            		$scope.parentData.projectName = row.entity.projectName;
            	            		$scope.parentData.managerId = row.entity.managerId;
            	            		$scope.parentData.managerName = row.entity.managerName;
            	            		$scope.parentData.experience = row.entity.experience;
            	            		$scope.parentData.designation = row.entity.designation;
            	            	}
            	            	
            	            	$scope.getMyTeamDetails = function(empid){
            	            		
            	            		$http({
            	            	        method : "GET",
            	            	        url : appConfig.appUri + "/projectTeam/getMyTeamDetails?employeeId="+empid
            	            	    }).then(function mySuccess(response) {
            	            	        $scope.gridOptions.data = response.data;
            	            	    }, function myError(response) {
            	            	    	showAlert("Something went wrong while fetching data!!!");
            	            	    	$scope.gridOptions.data = [];
            	            	    });
            	            	};
            	
            	            	
            	            	 $scope.drawChart = function(element,chartName,result,title){
            	            		Highcharts.chart(element[0], {
            	            			chart: {
            	            		        type: chartName
            	            			},
            	            			title: {
            	            		    	 text: title
            	            		    }, 
            	            		    xAxis: {
            	            		    	categories: ['Plan', 'Retail', 'Buy', 'Sell'],
            	            		    	labels:{
            	            		    		formatter: function() {
            	            		    	          if (chartName != 'pie' || chartName != 'line') {
            	            		    	        	  return this.value;
            	            		    	          } else{
            	            		    	        	  return '(Not Designated)';
            	            		    	          }
            	            		    	        }
            	            		    	},
            	            		    }, 
            	            			    legend: {
            	            			        align: 'right',
            	            			        x: -30,
            	            			        verticalAlign: 'top',
            	            			        y: 25,
            	            			        floating: true,
            	            			        backgroundColor: (Highcharts.theme && Highcharts.theme.background2) || 'white',
            	            			        borderColor: '#CCC',
            	            			        borderWidth: 1,
            	            			        shadow: false
            	            			    },
            	            			    tooltip: {
            	            			        headerFormat: '<b>{point.x}</b><br/>',
            	            			        pointFormat: '{series.name}: {point.y}'
            	            			    },
            	            			    plotOptions: {
            	            			        
            	            			        series:{
            	            		            	events:{
            	            		            		click: function(event) {
            	            		            			$scope.custom(event);
            	            		            		}
            	            		            	}
            	            		            }
            	            			    },
            	            		    series:  result
            	            	    });
            	            	}
            	            	 
            	            	 $scope.custom = function(category){
            	            			alert('custome method')
            	            			$scope.getMyTeamDetails('16207');
            	            		}
            	            	
            });
 

function getEmployeeDetails(scope,uri,chart,element,title){
var result = [];
	Highcharts.ajax({
        url: uri,
        success: function(data) {
        	if(chart=='line'){
        	result = data.seriesDataList;
        	scope.drawChart(element,chart,result,title);
        	}else if(chart == 'pie'){
            	result = data;
            	scope.drawChart(element,chart,result,title);
        	}
        }
    });
}